<template>
  <div :class="$style.wrapHeight">
    <div :class="$style.rowHeight">
      <audit-tree
        ref="problemTree"
        :checkable="false"
        :draggable="false"
        :is-search="false"
        :show-line="true"
        :top-node-text="'审计问题'"
        :treeparams="{
          configId: 91,
        }"
        :default-expanded-keys="['0']"
        :is-select-dep="true"
        manager-type="view"
        @treeSelect="treeSelectd"
      >
      </audit-tree>
      <div :class="$style.rightcard">
        <a-card>
          <div :class="$style.wrapper">
            <div :class="[$style.btns]">
              <audit-advanced-import
                ref="import"
                :config-id="'51'"
                :table-id="'oaTable'"
                :relevant-column="importTreeId"
                :v-if="false"
              >
              </audit-advanced-import>
            </div>

            <audit-advanced-query
              :expand="expand"
              :search-data="formData"
              :ref-name="'searchform'"
              :search-style="{ height: '125px', left: '20px', top: '64px', width: '100%' }"
              :search-fun="handleSearch"
              @searchedClick="searchedClick"
            >
              <template>
                <a-col :span="12">
                  <a-form-model-item :label="'问题标题'" prop="title">
                    <a-input v-model="formData.title" allow-clear />
                  </a-form-model-item>
                </a-col>
                <a-col :span="12">
                  <a-form-model-item :label="'编制人员'" prop="cUser">
                    <a-input v-model="formData.cUser" allow-clear />
                  </a-form-model-item>
                </a-col>
              </template>
            </audit-advanced-query>
            <sd-data-table-ex
              ref="oaTable"
              :editnode="editnode"
              :form-id="formId"
              :columns="columns"
              :actions="actions"
              :filter-expressions="expressions"
              :show-selection="true"
              :data-url="dataUrl"
              :show-advance-query="true"
              :search-fields="['docTitle']"
              :row-selection="{ type: 'radio' }"
              @recordsDeleted="onRecordsDeleted"
              @searchbtnClick="searchbtnClick"
            >
              <a
                slot="fldSubject"
                slot-scope="text, record"
                :title="text"
                @click="fnReadDoc(record)"
                >{{ text }}</a
              >

              <a slot="opt" slot-scope="text, record" @click="fnEditDoc(record)">编辑</a>
            </sd-data-table-ex>
            <!-- 导入弹窗 -->
            <iam-audit-source-problem-import-modal
              :parent-id="typeId + ''"
              :visible="importVisible"
            ></iam-audit-source-problem-import-modal>
          </div>
        </a-card>
      </div>
    </div>
  </div>
</template>

<script>
import { message, Modal } from 'ant-design-vue'
import PageService from '@/common/services/page-service'
import { getUserInfo, getUserPerms } from '@/common/store-mixin'
import TableActionTypes from '@/common/services/table-action-types'
import TableColumnTypes from '@/common/services/table-column-types'
import crossWindowWatcher from '@/common/services/cross-window-watcher'
import openAsTrustId from '@/common/services/open-as-trust-id'
import download from '@/common/services/download'
import auditAdvancedImport from '../../../components/audit-advanced-import.vue'
import auditAdvancedQueryMixins from '../../../components/audit-advanced-query-mixins'
import auditAdvancedQuery from '../../../components/audit-advanced-query.vue'
import auditTree from '../../../components/audit-tree.vue'
import iamAuditSourceProblemImportModal from './iam-audit-source-problem-import-modal.vue'
import problemService from './iam-source-problem-service.js'
import components from './_import-components/iam-source-problem-list-import'

export default {
  name: 'IamProblem',
  metaInfo: {
    title: '审计问题',
  },
  components: {
    auditTree,
    auditAdvancedQuery,
    auditAdvancedImport,
    iamAuditSourceProblemImportModal,
    ...components,
  },
  mixins: [auditAdvancedQueryMixins],

  props: {
    // 是不是用于选择知识
    isSelectd: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      importVisible: false, // 导入弹窗
      editnode: true,
      formData: {
        title: '',
        label: '',
        cUser: '',
      },
      dataUrl: 'api/xcoa-mobile/v1/iamproblem/all-list',
      expand: false,
      // 左侧树用，用于创建对应分类数据
      parentId: 0,
      importTreeId: 0,
      categorys: [],
      activeKey: 'textlist',
      isKmAdmin: false,
      expressions: [],
      columns: [
        {
          title: '序号',
          dataIndex: 'sortNumber',
          width: '80px',
          customRender: (text, record, index) => `${index + 1}`,
        },
        {
          title: '问题标题',
          dataIndex: 'docTitle',
          scopedSlots: { customRender: 'fldSubject' },
          width: '50%',
        },
        {
          title: '问题编号',
          dataIndex: 'problemNumber',
          // defaultSortOrder: 'asc',
        },
        {
          title: '维护人员',
          dataIndex: 'creatorName',
        },
        {
          title: '维护日期',
          dataIndex: 'creationTime',
          sdRender: TableColumnTypes.date,
          sorter: true,
          defaultSortOrder: 'desc',
        },
      ],
      actions: [
        {
          label: '删除',
          permission: 'delete', // 纯前端操作，不需要权限控制
          id: 'delete',
          type: TableActionTypes.oa.delete, // 删除按钮，不需要回调，会自动处理
          // callback: this.deleteRows,
        },
        {
          label: '新建',
          permission: 'create', // 纯前端操作，不需要权限控制
          id: 'create', // 没写type，一般按钮
          callback: () => {
            this.fnCreatDoc()
          },
          type: TableActionTypes.primary,
        },
        {
          label: '分类配置',
          id: 'auditMattersCatalog',
          permission: null,
          callback: () => {
            const url = '/sd-frame/iam-source-problem-category' // 新页面要打开的路由地址
            openAsTrustId(url, null)
          },
        },
        {
          label: '导入',
          id: 'importExcel', // 按钮id
          permission: 'create', // 有创建的权限才能导入
          // type: TableActionTypes.primary,
          callback: () => {
            // this.$refs.import.showImportPanel()
            this.showImportModal()
          },
        },
        {
          label: '导出',
          id: 'exportProblem',
          permission: null,
          callback: this.exportProblem, // 纯前端操作，不需要权限控制
        },
      ],
      businessTypeId: null,
      typeId: null,
      typeName: '',

      formId: 'iamProblem',
      // 图文列表参数
      showCreateBtn: false,
      showDeleteBtn: false,
      pictureData: [],
      pagination: {
        onChange: (page) => {
          this.paginationChange(page)
        },
        current: 1,
        pageSize: 8,
        showTotal(total) {
          return `共${total}条`
        },
      },
      loading: false, // 图文列表数据的loading
      orderType: 'creationTime',
      creationTimeDesc: true,
      pictureRowSelection: [],
      searchText: '',
      picList: '',
    }
  },
  // 图文列表参数变化更新数据
  watch: {
    orderType() {
      this.pictureListRefresh()
    },
    creationTimeDesc() {
      this.pictureListRefresh()
    },
  },
  created() {
    if (getUserInfo().roles.findIndex((item) => item.code === 'KM_ADMIN') !== -1) {
      this.isKmAdmin = true
    }
    // 图文列表获取数据
    this.treeSelectd({}, { id: 0 })
  },
  methods: {
    // 显示导入弹窗
    showImportModal() {
      this.importVisible = !this.importVisible
    },
    searchedClick() {
      this.expand = false
    },
    // 查询
    handleSearch() {
      this.expressions = [
        {
          dataType: 'str',
          name: 'parentId',
          op: 'eq',
          stringValue: this.typeId,
        },
      ]

      // 资料名称
      if (this.formData.title) {
        this.expressions.push({
          dataType: 'str',
          name: 'docTitle',
          op: 'like',
          stringValue: `%${this.formData.title}%`,
        })
      }

      // 资料名称
      if (this.formData.cUser) {
        this.expressions.push({
          dataType: 'str',
          name: 'creatorName',
          op: 'like',
          stringValue: `%${this.formData.cUser}%`,
        })
      }
    },

    // 树选择节点后获取列表数据
    treeSelectd(key, item) {
      if (item.selectedNodes?.length > 0) {
        let parentId = ''
        let parentName = ''
        if (item.id !== undefined) {
          parentId = item.id
          parentName = item.text
        } else {
          parentId = item.selectedNodes[0].data.props.id
          parentName = item.selectedNodes[0].data.props.text
          this.editnode = item.selectedNodes[0].data.props.edit
        }
        this.typeId = parentId
        this.importTreeId = parentId
        this.typeName = parentName

        this.selectdParentName = parentName
        const filter = [
          {
            dataType: 'str',
            name: 'parentId',
            op: 'eq',
            stringValue: this.typeId,
          },
        ]

        this.expressions = filter
      } else {
        const filter = {
          dataType: 'str',
          name: 'parentId',
          op: 'eq',
          stringValue: -1,
        }

        this.expressions = [filter]
        this.editnode = false
      }
    },

    // 获取businessTypeId，选中的节点要是没有businessTypeId就向上找，直至找到根节点，如果没有就返回null
    fnGetBusinessTypeId(item) {
      let businessTypeId
      if (item === null) {
        // 如果找到根节点都没找到flowId就返回null
        businessTypeId = null
      } else {
        if (item.selectedNodes && item.selectedNodes[0].data.props.props.businessTypeId) {
          businessTypeId = item.selectedNodes[0].data.props.props.businessTypeId
        } else if (item.props && item.props.businessTypeId) {
          businessTypeId = item.props.businessTypeId
        } else {
          const key = item.id ? item.id : item.selectedNodes[0].data.key
          const parentNode = this.getParentNode(key, this.$refs.tree.treeData)
          businessTypeId = this.fnGetBusinessTypeId(parentNode)
        }
      }
      return businessTypeId
    },

    // 查找父节点
    getParentNode(key, tree) {
      let parentNode = null
      for (let i = 0; i < tree.length; i++) {
        const node = tree[i]
        if (node.children) {
          if (node.children.some((item) => item.id === key)) {
            parentNode = node
          } else if (this.getParentNode(key, node.children)) {
            parentNode = this.getParentNode(key, node.children)
          }
        }
      }
      return parentNode
    },

    // 知识投稿
    fnCreatDoc() {
      debugger
      var url =
        '/iam-source-problem-form?' +
        '&typeId=' +
        this.typeId +
        '&typeName=' +
        this.typeName +
        '&orgId=' +
        this.$refs.problemTree.depvalue
      crossWindowWatcher.waitForChanged(url).then((refreshFlag) => {
        if (refreshFlag) {
          return this.$refs.oaTable.refresh(true)
        }
      })
    },
    fnEditDoc(record) {
      setTimeout(() => {
        this.$refs.oaTable.refresh()
        this.loadData()
      }, 5000)

      var url = `/km-knowledage-form?&typeId=${this.typeId}&typeName=${this.typeName}&record=${record.id}`

      crossWindowWatcher.waitForChanged(url).then((refreshFlag) => {
        if (refreshFlag) {
          return this.$refs.oaTable.refresh(true)
        }
      })
    },
    // 查看知识
    fnReadDoc(record) {
      setTimeout(() => {
        this.$refs.oaTable.refresh()
        this.loadData()
      }, 5000)
      window.open(`#/iam-source-problem-form?id=${record.id}&title=${record.docTitle}`, '_blank')
    },

    // 图片列表页面翻页
    paginationChange(page) {
      this.pagination.current = page
      this.loadData()
    },

    pictureListRefresh(toFirstPage) {
      if (toFirstPage) this.pagination.current = 1
      if (!this.isSelectd) {
        return this.loadData()
      }
    },
    // 列表删除数据时刷新一下
    onRecordsDeleted() {
      this.$refs.tree.refresh() // 刷新树
    },
    // 列表删除数据
    deleteRows() {
      const selectedRowKeys = this.$refs.oaTable.getSelectedRowKeys()
      if (selectedRowKeys.length === 0) {
        Modal.info({
          content: '请选择需要删除的文件',
        })
        return
      }
      Modal.confirm({
        title: '你确定删除这项内容吗？',
        content: '删除这条数据后，就无法恢复初始的状态。',
        okText: '删除',
        okType: 'danger',
        onOk: () => {
          this.loading = true
          const params = {
            ids: selectedRowKeys.join(','),
          }

          PageService.delete(params, this.formId).then((res) => {
            if (res.status === 200) {
              this.$refs.oaTable.clearSelection()
              this.$refs.oaTable.refresh()
              this.loading = false
              message.success('删除成功')
            }
          })
        },
      })
    },

    onSearchChange(text) {
      if (this.searchText === text) return
      this.searchText = text.trim()
      const pagination = this.pagination
      pagination.current = 1
      this.localPagination = { ...pagination }
      this.loadData()
    },

    // 导出
    exportProblem() {
      const rootId = this.$refs.problemTree.depvalue
      const id = this.typeId
      problemService.exportProblem(id, rootId).then((res) => {
        if (res.status === 200) {
          const url = URL.createObjectURL(res.data)
          const filename = res.headers['content-disposition']
          const fname = filename.substring(filename.indexOf('filename=') + 9, filename.length)
          download(url, decodeURI(fname))
        } else {
          Modal.warning({
            title: '提示',
            content: '导出报错，请联系管理员!',
          })
          return false
        }
      })
    },
  },
}
</script>

<style module lang="scss">
@use '@/common/design' as *;
.wrap-height {
  height: 100%;
  .row-height {
    display: flex;
    flex: auto;
    height: 100%;
    .rightcard {
      flex: 1;
      width: calc(100% - 20%);
      height: 100%;
    }
  }
}

.sider-content {
  padding: 0 0;
  .sider-title {
    position: relative;
    margin-left: 23px;
    i {
      color: #1890ff;
      position: absolute;
      font-size: 18px;
      left: -27px;
      top: 3px;
    }
    font-weight: bold;
  }
  .sider-li {
    :global(.ant-timeline-item-content) {
      margin: 0 0 0 23px;
    }
    :global(.ant-timeline-item-head-blue) {
      color: #9f9f9f;
      border-color: #9f9f9f;
    }
    :global(.ant-timeline-item-tail) {
      height: calc(100% - -18px);
      border-left: 2px solid #f5f5f5;
    }
  }
  .sider-title-div-first {
    padding: 0 0 10px 20px;
    margin-bottom: 10px;
    border-bottom: 3px solid #e8e8e8;
  }
  .sider-title-div {
    padding: 10px 0 10px 20px;
    margin-bottom: 20px;
    border-top: 3px solid #e8e8e8;
    border-bottom: 3px solid #e8e8e8;
  }
  ul {
    margin-left: 0;
    margin-bottom: 30px;
  }
  .sider-ul-div {
    padding: 13px 0px 0px 5px;
    width: 90%;
    margin: 10px auto;
    border-radius: 5px;
    cursor: pointer;
    :global(.ant-timeline-item) {
      padding: 0;
      margin-left: 3px;
    }
  }
  :global(.checked) {
    background: linear-gradient(to right, #13c2c2, #2db7f5);
    color: #fff;
    :global(.ant-timeline-item-head-blue) {
      background-color: #13c2c2;
      border-color: #ffffff !important;
    }
  }
  :global(.ant-timeline-item-last .ant-timeline-item-tail) {
    display: none;
  }
}
</style>
